POJ 3635 Full Tank?

题意:告诉你n个城市的油价和m条道路的距离。Q次询问,告诉你出发点,目的地以及油箱的最大容量,要求问答最少花费是多少。

思路:参考了网上的思路http://blog.csdn.net/sdj222555/article/details/7693093   SPFA+优先队列

        用类似于dp的思想,dp[i][j]表示到达第i个城市剩余j升油的最小花费。维护一个优点队列,一开始我的思路是对于当前节点相连的每一条边从边的长度开始+1直到加到油箱容量的限制,然后把所有的点入队

然后这样做爆栈了。然后只能参考网上的思路,把当前的油量加1入队,然后如果可以到达下一个节点,就把下一个节点入队,当然要减去边的花费。可是这个时候TLE了。因为我进行了一次完整的SPFA。因为

我们维护的是一个优先队列,所以当目的节点第一次出队的时候,必然就是最小值,即我们所求的答案。然后终于A了。407MS水过。

在这个题还学会了自定义结构体的优先队列使用。参考了博客http://blog.csdn.net/dooder_daodao/article/details/5761550

在初始化结构体的优先队列时需要要再定义一个cmp结构体作为比较。

#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <map>
#include <queue>
using namespace std;

const int INF=0x3f3f3f3f;
const int MAXN=1100;
const int MAXM=110000;

int val[MAXN];

int n,m,u,v,w,q,cc,ss,ee,tot;
int dp[MAXN][110];
int head[MAXN];
struct Edge{
    int v,w,nex;
}edge[MAXM*2];

struct Node{
    int cost,u,lef;
};

struct cmp{
    bool operator()(Node a,Node b)
    {
        return a.cost>b.cost;
    }
};

void addedge(int u,int v,int w)
{
    edge[tot].v=v;
    edge[tot].w=w;
    edge[tot].nex=head[u];
    head[u]=tot++;

    edge[tot].v=u;
    edge[tot].w=w;
    edge[tot].nex=head[v];
    head[v]=tot++;
}

void init()
{
    tot=0;
    memset(head,-1,sizeof(head));
}

priority_queue<Node,vector<Node>,cmp> que;

void SPFA()
{
    for(int i=0;i<MAXN;i++)
        for(int j=0;j<110;j++)
            dp[i][j]=INF;

    while(!que.empty())
        que.pop();

    Node u,node;
    u.cost=0;
    u.lef=0;
    u.u=ss;
    que.push(u);
    while(!que.empty())
    {
        u=que.top();
        que.pop();
        if(dp[u.u][u.lef]<=u.cost)
            continue;
        dp[u.u][u.lef]=u.cost;
        if(u.u==ee)
            return ;
        if(u.lef<cc&&dp[u.u][u.lef+1]>u.cost+val[u.u])
        {
            node.u=u.u;
            node.cost=u.cost+val[u.u];
            node.lef=u.lef+1;
            que.push(node);
        }
        for(int i=head[u.u];i!=-1;i=edge[i].nex)
        {
            Edge e=edge[i];
            if(e.w>u.lef)
                continue;
            node.cost=u.cost;
            node.u=e.v;
            node.lef=u.lef-e.w;
            que.push(node);
            /*
            for(int j=max(u.lef,e.w);j<=cc;j++)
            {
                Node node;
                node.cost=u.cost+(j-u.lef)*val[u.u];
                node.u=e.v;
                node.lef=j-e.w;
                que.push(node);
            }
            */
        }
    }
}

int main()
{
    freopen("in.txt","r",stdin);

    while(scanf("%d%d",&n,&m)!=EOF)
    {
        init();
        for(int i=0;i<n;i++)
            scanf("%d",&val[i]);

        for(int i=0;i<m;i++)
        {
            scanf("%d%d%d",&u,&v,&w);
            addedge(u,v,w);
        }
        scanf("%d",&q);
        for(int i=0;i<q;i++)
        {
            scanf("%d%d%d",&cc,&ss,&ee);
            SPFA();
            if(dp[ee][0]!=INF)
                printf("%d\n",dp[ee][0]);
            else
                printf("impossible\n");
        }
    }
    return 0;
}

时间: 2024-11-06 22:19:08

POJ 3635 Full Tank?的相关文章

poj 3635 Full Tank? ( 图上dp )

题意: 已知每个点的加油站的油价单价(即点权),每条路的长度(边权). 有q个询问,每个询问包括起点s.终点e和油箱容量. 问从起点走到终点的最小花费.如果不可达输出impossible,否则输出最小的旅途费用. 算法: 其实要分析状态= =感觉就像是dp. 最直接的想法是  每到一个点都加上要走到下一个点所需要的油量.但是走的路不同,到底怎么处理加多少的问题呢? 因此想到分解状态,即拆点.每到一个点都+1单位的油量,然后把这个状态加入队列.另外如果现在油箱内的油足够达到下一点, 则更新状态,把

poj 3635 Full Tank 动态规划思想在spfa算法中的应用

题意: 有n个城市,和m条已知长度的路,在路上走1单位距离要花1单位油,每个城市都可以加油且有各自的油价,现在任给两个城市s,t,要求从s到t最少花多少油. 思路: 网上大多数都是拿优先队列做的,拿spfa做更有意思,但一般的spfa会超时.dis[i][j]表示到城市i时油箱里有j单位油时的最小花费.对于城市x,y,他们的距离为w,如果存在dis[x][j]<dis[y][i-w],则确定对y进行更新,注意如果对每个dis[x][j]<dis[y][j-w],dis[x][j+1]<d

poj 3635/hdu 1676 Full Tank? 车辆加油+最短路

http://acm.hdu.edu.cn/showproblem.php?pid=1676 给出一张图,n<=1000,m<=10000. 有一辆车想从图的一个地方到达另外一个地方,每个点是一个卖油的地方,每个地方买的有价格不一样,车的最大装油量是c<=100,求初始点到终止点的最小花费. 可以 dp[i][j] 表示走到i点剩余j个单位的汽油时的最小花费,难点在于车需要加油,加多少油,转换问题后发现还是简单的bfs 就是维护一个费用优先队列,每到达一个节点都有两种可扩展的状态,一是加

POJ 3635 BFS+优先队列

Full Tank? Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 6326   Accepted: 2086 Description After going through the receipts from your car trip through Europe this summer, you realised that the gas prices varied between the cities you v

【图论补完计划】poj 3635 (最短路变形)

Full Tank? Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 7427   Accepted: 2399 Description After going through the receipts from your car trip through Europe this summer, you realised that the gas prices varied between the cities you v

(BFS) poj 3635

Full Tank? Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 6724   Accepted: 2194 Description After going through the receipts from your car trip through Europe this summer, you realised that the gas prices varied between the cities you v

图论常用算法之一 POJ图论题集【转载】

POJ图论分类[转] 一个很不错的图论分类,非常感谢原版的作者!!!在这里分享给大家,爱好图论的ACMer不寂寞了... (很抱歉没有找到此题集整理的原创作者,感谢知情的朋友给个原创链接) POJ:http://poj.org/ 1062* 昂贵的聘礼 枚举等级限制+dijkstra 1087* A Plug for UNIX 2分匹配 1094 Sorting It All Out floyd 或 拓扑 1112* Team Them Up! 2分图染色+DP 1125 Stockbroker

[转] 一些图论、网络流入门题总结、汇总

最短路问题此类问题类型不多,变形较少 POJ 2449 Remmarguts' Date(中等)http://acm.pku.edu.cn/JudgeOnline/problem?id=2449题意:经典问题:K短路解法:dijkstra+A*(rec),方法很多相关:http://acm.pku.edu.cn/JudgeOnline/showcontest?contest_id=1144该题亦放在搜索推荐题中 POJ 3013 - Big Christmas Tree(基础)http://ac

【转】一些图论、网络流入门题总结、汇总

最短路问题 此类问题类型不多,变形较少 POJ 2449 Remmarguts' Date(中等) http://acm.pku.edu.cn/JudgeOnline/problem?id=2449 题意:经典问题:K短路 解法:dijkstra+A*(rec),方法很多 相关:http://acm.pku.edu.cn/JudgeOnline/showcontest?contest_id=1144 该题亦放在搜索推荐题中 POJ 3013 - Big Christmas Tree(基础) ht